#--
# *** This code is copyright 2004 by Gavin Kistner
# *** It is covered under the license viewable at http://phrogz.net/JS/_ReuseLicense.txt
# *** Reuse or modification is free provided you abide by the terms of that license.
# *** (Including the first two lines above in your source code usually satisfies the conditions.)
#++
#
# This file describes the HashStruct class. See its documentation for more info.
# Author::     Gavin Kistner  (mailto:!@phrogz.net)
# Copyright::  Copyright (c)2004 Gavin Kistner
# License::    See http://Phrogz.net/JS/_ReuseLicense.txt for details
# Version::    1.0b
# Full Code::  link:../HashStruct.rb

require 'ostruct'

# A mix of Hash and OpenStruct behavior.
#   foo = HashStruct.new
#   foo.bar = "Hello"
#   foo['jimmy'] = "World"
#   x = :jammy
#   foo[x] = "How goes it?"
#   p foo
#   #=> <HashStruct bar="Hello" jammy="How goes it?" jimmy="World">
class HashStruct < OpenStruct
	# Access a value in the HashStruct by key.
	#
	# _key_ may be a String, Fixnum or Symbol.
	def [](key)
		key = key.to_sym unless key.is_a?(Symbol)
		@table[key]
	end
	
	# Set a key/value pair the HashStruct.
	#
	# _key_ may be a String, Fixnum or Symbol.
	def []=(key,val)
		raise TypeError, "can't modify frozen #{self.class}", caller(1) if self.frozen?
		key = key.to_sym unless key.is_a?(Symbol)
		@table[key]=val
	end
end
